#!/bin/sh

RESET="$(tput -Txterm sgr0)"
RED="$(tput -Txterm setaf 1)"
GREEN="$(tput -Txterm setaf 2)"
YELLOW="$(tput -Txterm setaf 3)"

sites_dir="./nginx/sites-enabled/"

get_param(){
  grep "$1" "${sites_dir}${filename}" | xargs | cut -d ' ' -f "$2" | sed 's/;//'
}


for filename in $(ls "$sites_dir" | sort -d); do
  listen_to="$(get_param listen 2)"
  PROTO="https"
  if [ 80 = "$listen_to" ]; then
    PROTO="http"
  fi
  ADDR="$(get_param server_name 2)"
  if [ "$ADDR" = "_" ];then
    continue;
  fi
  PROXY="$(get_param "set \$target" 3)"
  if [ -z "$PROXY" ];then
    continue;
  fi
  STATUS="${GREEN}[  UP  ]"
  URL="$PROTO://${ADDR}"
  STATUS_CODE="$(curl -o /dev/null -s -w "%{http_code}\n" "$URL")"
  if [ "$STATUS_CODE" = "000" ];then
    STATUS="${YELLOW}[CLOSED]"
    else if [ "$STATUS_CODE" = "502" ];then
    STATUS="${RED}[ DOWN ]"  
    fi
  fi
  echo "$STATUS (${STATUS_CODE}) ${URL}${RESET} => ${YELLOW}${PROXY}${RESET}";
done
